package com.gct.tools.etlcamelhuge.MQ;

import lombok.extern.slf4j.Slf4j;

import java.io.File;
import java.io.IOException;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.logging.FileHandler;
import java.util.logging.Formatter;
import java.util.logging.LogRecord;
import java.util.logging.Logger;

/**
 * class name: DiagnoseMsgSendFailCallBack
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/7/05 下午7:08
 */
@Slf4j
public class DefaultMsgSendFailCallBack {

    public synchronized static void  accept(MessageBody msg, String logFilePath) {
        String msgJson = msg.toJsonBody();
        String fileName = logFilePath + "-" + LocalDate.now().format(DateTimeFormatter.ISO_DATE);
        File file = new File(fileName);
        if (!file.getParentFile().exists())
            if (!file.getParentFile().mkdirs()) {
                log.error("create log file failed,method:mkdirs()");
                return;
            }
        if (!file.exists()) {
            try {
                if (!file.createNewFile()) {
                    log.error("create log file failed,method:createNewFile()");
                    return;
                }
            } catch (IOException ioException) {
                log.error("create log file failed, cause by:{}", ioException.getMessage());
                return;
            }
        }
        try {
            FileHandler fileHandler = new FileHandler(fileName, true);
            fileHandler.setFormatter(new Formatter() {
                @Override
                public String format(LogRecord logRecord) {
                    return logRecord.getMessage();
                }
            });
            Logger logger = Logger.getLogger(DefaultMsgSendFailCallBack.class.getTypeName());
            logger.setUseParentHandlers(false);
            logger.addHandler(fileHandler);
            logger.info(msgJson + "\n");

        } catch (IOException ioException) {
            log.error("run logger handler failed, cause by:{}", ioException.getMessage());
        }


    }
}
